Browse Source

Merge branch 'maint'

* maint:
  GIT 1.6.4.3
  svn: properly escape arguments for authors-prog
  http.c: remove verification of remote packs
  grep: accept relative paths outside current working directory
  grep: fix exit status if external_grep() punts

Conflicts:
	GIT-VERSION-GEN
	RelNotes
maint
Junio C Hamano 15 years ago
parent
commit
5b590d783a
  1. 29
      Documentation/RelNotes-1.6.4.3.txt
  2. 3
      Documentation/git.txt
  3. 39
      builtin-grep.c
  4. 1
      git-svn.perl
  5. 1
      grep.h
  6. 11
      http.c
  7. 17
      t/t7002-grep.sh
  8. 14
      t/t9138-git-svn-authors-prog.sh

29
Documentation/RelNotes-1.6.4.3.txt

@ -0,0 +1,29 @@ @@ -0,0 +1,29 @@
GIT v1.6.4.3 Release Notes
==========================

Fixes since v1.6.4.2
--------------------

* "git clone" from an empty repository gave unnecessary error message,
even though it did everything else correctly.

* "git cvsserver" invoked git commands via "git-foo" style, which has long
been deprecated.

* "git fetch" and "git clone" had an extra sanity check to verify the
presense of the corresponding *.pack file before downloading *.idx
file by issuing a HEAD request. Github server however sometimes
gave 500 (Internal server error) response to HEAD even if a GET
request for *.pack file to the same URL would have succeeded, and broke
clone over HTTP from some of their repositories. As a workaround, this
verification has been removed (as it is not absolutely necessary).

* "git grep" did not like relative pathname to refer outside the current
directory when run from a subdirectory.

* an error message from "git push" was formatted in a very ugly way.

* "git svn" did not quote the subversion user name correctly when
running its author-prog helper program.

Other minor documentation updates are included.

3
Documentation/git.txt

@ -43,9 +43,10 @@ unreleased) version of git, that is available from 'master' @@ -43,9 +43,10 @@ unreleased) version of git, that is available from 'master'
branch of the `git.git` repository.
Documentation for older releases are available here:

* link:v1.6.4.2/git.html[documentation for release 1.6.4.2]
* link:v1.6.4.3/git.html[documentation for release 1.6.4.3]

* release notes for
link:RelNotes-1.6.4.3.txt[1.6.4.3],
link:RelNotes-1.6.4.2.txt[1.6.4.2],
link:RelNotes-1.6.4.1.txt[1.6.4.1],
link:RelNotes-1.6.4.txt[1.6.4].

39
builtin-grep.c

@ -13,6 +13,7 @@ @@ -13,6 +13,7 @@
#include "parse-options.h"
#include "userdiff.h"
#include "grep.h"
#include "quote.h"

#ifndef NO_EXTERNAL_GREP
#ifdef __unix__
@ -157,8 +158,8 @@ static int grep_sha1(struct grep_opt *opt, const unsigned char *sha1, const char @@ -157,8 +158,8 @@ static int grep_sha1(struct grep_opt *opt, const unsigned char *sha1, const char
unsigned long size;
char *data;
enum object_type type;
char *to_free = NULL;
int hit;
struct strbuf pathbuf = STRBUF_INIT;

data = read_sha1_file(sha1, &type, &size);
if (!data) {
@ -166,26 +167,13 @@ static int grep_sha1(struct grep_opt *opt, const unsigned char *sha1, const char @@ -166,26 +167,13 @@ static int grep_sha1(struct grep_opt *opt, const unsigned char *sha1, const char
return 0;
}
if (opt->relative && opt->prefix_length) {
static char name_buf[PATH_MAX];
char *cp;
int name_len = strlen(name) - opt->prefix_length + 1;

if (!tree_name_len)
name += opt->prefix_length;
else {
if (ARRAY_SIZE(name_buf) <= name_len)
cp = to_free = xmalloc(name_len);
else
cp = name_buf;
memcpy(cp, name, tree_name_len);
strcpy(cp + tree_name_len,
name + tree_name_len + opt->prefix_length);
name = cp;
}
quote_path_relative(name + tree_name_len, -1, &pathbuf, opt->prefix);
strbuf_insert(&pathbuf, 0, name, tree_name_len);
name = pathbuf.buf;
}
hit = grep_buffer(opt, name, data, size);
strbuf_release(&pathbuf);
free(data);
free(to_free);
return hit;
}

@ -195,6 +183,7 @@ static int grep_file(struct grep_opt *opt, const char *filename) @@ -195,6 +183,7 @@ static int grep_file(struct grep_opt *opt, const char *filename)
int i;
char *data;
size_t sz;
struct strbuf buf = STRBUF_INIT;

if (lstat(filename, &st) < 0) {
err_ret:
@ -219,8 +208,9 @@ static int grep_file(struct grep_opt *opt, const char *filename) @@ -219,8 +208,9 @@ static int grep_file(struct grep_opt *opt, const char *filename)
}
close(i);
if (opt->relative && opt->prefix_length)
filename += opt->prefix_length;
filename = quote_path_relative(filename, -1, &buf, opt->prefix);
i = grep_buffer(opt, filename, data, sz);
strbuf_release(&buf);
free(data);
return i;
}
@ -503,6 +493,7 @@ static int grep_cache(struct grep_opt *opt, const char **paths, int cached, @@ -503,6 +493,7 @@ static int grep_cache(struct grep_opt *opt, const char **paths, int cached,
hit = external_grep(opt, paths, cached);
if (hit >= 0)
return hit;
hit = 0;
}
#endif

@ -798,6 +789,7 @@ int cmd_grep(int argc, const char **argv, const char *prefix) @@ -798,6 +789,7 @@ int cmd_grep(int argc, const char **argv, const char *prefix)
};

memset(&opt, 0, sizeof(opt));
opt.prefix = prefix;
opt.prefix_length = (prefix && *prefix) ? strlen(prefix) : 0;
opt.relative = 1;
opt.pathname = 1;
@ -868,15 +860,8 @@ int cmd_grep(int argc, const char **argv, const char *prefix) @@ -868,15 +860,8 @@ int cmd_grep(int argc, const char **argv, const char *prefix)
verify_filename(prefix, argv[j]);
}

if (i < argc) {
if (i < argc)
paths = get_pathspec(prefix, argv + i);
if (opt.prefix_length && opt.relative) {
/* Make sure we do not get outside of paths */
for (i = 0; paths[i]; i++)
if (strncmp(prefix, paths[i], opt.prefix_length))
die("git grep: cannot generate relative filenames containing '..'");
}
}
else if (prefix) {
paths = xcalloc(2, sizeof(const char *));
paths[0] = prefix;

1
git-svn.perl

@ -2836,6 +2836,7 @@ sub other_gs { @@ -2836,6 +2836,7 @@ sub other_gs {

sub call_authors_prog {
my ($orig_author) = @_;
$orig_author = command_oneline('rev-parse', '--sq-quote', $orig_author);
my $author = `$::_authors_prog $orig_author`;
if ($? != 0) {
die "$::_authors_prog failed with exit code $?\n"

1
grep.h

@ -59,6 +59,7 @@ struct grep_opt { @@ -59,6 +59,7 @@ struct grep_opt {
struct grep_pat *pattern_list;
struct grep_pat **pattern_tail;
struct grep_expr *pattern_expression;
const char *prefix;
int prefix_length;
regex_t regexp;
int linenum;

11
http.c

@ -869,17 +869,6 @@ static int fetch_pack_index(unsigned char *sha1, const char *base_url) @@ -869,17 +869,6 @@ static int fetch_pack_index(unsigned char *sha1, const char *base_url)
char *url;
struct strbuf buf = STRBUF_INIT;

/* Don't use the index if the pack isn't there */
end_url_with_slash(&buf, base_url);
strbuf_addf(&buf, "objects/pack/pack-%s.pack", hex);
url = strbuf_detach(&buf, 0);

if (http_get_strbuf(url, NULL, 0)) {
ret = error("Unable to verify pack %s is available",
hex);
goto cleanup;
}

if (has_pack_index(sha1)) {
ret = 0;
goto cleanup;

17
t/t7002-grep.sh

@ -328,4 +328,21 @@ test_expect_success 'grep -p -B5' ' @@ -328,4 +328,21 @@ test_expect_success 'grep -p -B5' '
test_cmp expected actual
'

test_expect_success 'grep from a subdirectory to search wider area (1)' '
mkdir -p s &&
(
cd s && git grep "x x x" ..
)
'

test_expect_success 'grep from a subdirectory to search wider area (2)' '
mkdir -p s &&
(
cd s || exit 1
( git grep xxyyzz .. >out ; echo $? >status )
! test -s out &&
test 1 = $(cat status)
)
'

test_done

14
t/t9138-git-svn-authors-prog.sh

@ -66,4 +66,18 @@ test_expect_success 'authors-file overrode authors-prog' ' @@ -66,4 +66,18 @@ test_expect_success 'authors-file overrode authors-prog' '
)
'

git --git-dir=x/.git config --unset svn.authorsfile
git --git-dir=x/.git config --unset svn.authorsprog

test_expect_success 'authors-prog handled special characters in username' '
svn mkdir -m bad --username "xyz; touch evil" "$svnrepo"/bad &&
(
cd x &&
git svn --authors-prog=../svn-authors-prog fetch &&
git rev-list -1 --pretty=raw refs/remotes/git-svn |
grep "^author xyz; touch evil <xyz; touch evil@example\.com> " &&
! test -f evil
)
'

test_done

Loading…
Cancel
Save